import { Injectable } from '@nestjs/common';
import { BaseDetailManager } from 'src/core/modules/domain/usecase/managers/base-detail.manager';
import { ItemQueueEntity } from '../../entities/item-queue.entity';
import { RelationParam } from 'src/core/modules/domain/entities/base-filter.entity';

@Injectable()
export class DetailItemQueueManager extends BaseDetailManager<ItemQueueEntity> {
  async prepareData(): Promise<void> {
    return;
  }

  async beforeProcess(): Promise<void> {
    return;
  }

  async afterProcess(): Promise<void> {
    return;
  }

  get relations(): RelationParam {
    return {
      joinRelations: [],
      selectRelations: ['items'],
      countRelations: [],
    };
  }

  get selects(): string[] {
    return [
      `${this.tableName}.id`,
      `${this.tableName}.status`,
      `${this.tableName}.name`,
      `${this.tableName}.item_type`,
      `${this.tableName}.created_at`,
      `${this.tableName}.creator_name`,
      `${this.tableName}.updated_at`,
      `${this.tableName}.editor_name`,

      `items.id`,
      `items.created_at`,
      `items.status`,
      `items.item_type`,
      `items.name`,
      `items.hpp`,
      `items.limit_type`,
      `items.limit_value`,
      `items.base_price`,
      `items.share_profit`,
      `items.play_estimation`,
    ];
  }

  get setFindProperties(): any {
    return {
      id: this.dataId,
    };
  }
}
